<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for get-status-response StructType
 * @subpackage Structs
 */
class Get_status_response extends AbstractStructBase
{
    /**
     * The task_status_info
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Task_status_info[]
     */
    public $task_status_info;
    /**
     * Constructor method for get-status-response
     * @uses Get_status_response::setTask_status_info()
     * @param \StructType\Task_status_info[] $task_status_info
     */
    public function __construct(array $task_status_info = array())
    {
        $this
            ->setTask_status_info($task_status_info);
    }
    /**
     * Get task_status_info value
     * @return \StructType\Task_status_info[]|null
     */
    public function getTask_status_info()
    {
        return $this->{'task-status-info'};
    }
    /**
     * This method is responsible for validating the values passed to the setTask_status_info method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTask_status_info method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTask_status_infoForArrayConstraintsFromSetTask_status_info(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $get_status_responseTask_status_infoItem) {
            // validation for constraint: itemType
            if (!$get_status_responseTask_status_infoItem instanceof \StructType\Task_status_info) {
                $invalidValues[] = is_object($get_status_responseTask_status_infoItem) ? get_class($get_status_responseTask_status_infoItem) : sprintf('%s(%s)', gettype($get_status_responseTask_status_infoItem), var_export($get_status_responseTask_status_infoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The task_status_info property can only contain items of type \StructType\Task_status_info, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set task_status_info value
     * @throws \InvalidArgumentException
     * @param \StructType\Task_status_info[] $task_status_info
     * @return \StructType\Get_status_response
     */
    public function setTask_status_info(array $task_status_info = array())
    {
        // validation for constraint: array
        if ('' !== ($task_status_infoArrayErrorMessage = self::validateTask_status_infoForArrayConstraintsFromSetTask_status_info($task_status_info))) {
            throw new \InvalidArgumentException($task_status_infoArrayErrorMessage, __LINE__);
        }
        $this->task_status_info = $this->{'task-status-info'} = $task_status_info;
        return $this;
    }
    /**
     * Add item to task_status_info value
     * @throws \InvalidArgumentException
     * @param \StructType\Task_status_info $item
     * @return \StructType\Get_status_response
     */
    public function addToTask_status_info(\StructType\Task_status_info $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Task_status_info) {
            throw new \InvalidArgumentException(sprintf('The task_status_info property can only contain items of type \StructType\Task_status_info, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->task_status_info[] = $this->{'task-status-info'}[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_status_response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
